-- Global Variables
targetDead = false
zoneFire = false
zoneViolation = 0
alt5 = 0
alt10 = 0
alt20 = 0

-- Local Variables
local lowAltitude = 1000
local highAltitude = 0
local totalAltitude = 0
local averageAltitude = 0
local ticAltitude = 0
local buzzSound = USERSOUND:New("zonebuzz.ogg")
local startTime = timer.getTime()
local stopTime = 0
local gpPlayer = GROUP:FindByName("l39")
local  uPlayer = UNIT:FindByName("l39")
local z1 = ZONE:New("zoneRestricted01")
local z2 = ZONE:New("zoneRestricted02")
local z3 = ZONE:New("zoneRestricted03")
local z4 = ZONE:New("zoneRestricted04")
local z5 = ZONE:New("zoneRestricted05")
local z6 = ZONE:New("zoneRestricted06")
local z7 = ZONE:New("zoneRestricted07")
local z8 = ZONE:New("zoneRestricted08")
local z9 = ZONE:New("zoneRestricted09")
local z10 = ZONE:New("zoneRestricted10")
local z11 = ZONE:New("zoneRestricted11")
local z12 = ZONE:New("zoneRestricted12")
local z13 = ZONE:New("zoneRestricted13")
local z14 = ZONE:New("zoneRestricted14")
local z15 = ZONE:New("zoneRestricted15")

-- This method rank the racers, including the player
function RankRacer(playerTime)

  local ranking = 10
  local racerList = {}
  
  -- Insert racers data in a table
  table.insert(racerList,{Name = "Thunderbirds", Country="USA",Pilot="Jim Kendel",Time=((math.random(200,275)) + ((math.random(1,99))/100))})
  table.insert(racerList,{Name = "Blue Angels", Country="USA",Pilot="Jackson Jones",Time=((math.random(175,225)) + ((math.random(1,99))/100))})
  table.insert(racerList,{Name = "Snowbirds", Country="Canada",Pilot="Glen Sholtz",Time=((math.random(225,300)) + ((math.random(1,99))/100))})
  table.insert(racerList,{Name = "Russian Knights", Country="Russia",Pilot="Dimitri Budanova",Time=((math.random(225,300)) + ((math.random(1,99))/100))})
  table.insert(racerList,{Name = "Ukrainian Falcons", Country="Ukraine",Pilot="Alexey Pugachev",Time=((math.random(300,375)) + ((math.random(1,99))/100))})
  table.insert(racerList,{Name = "Team 60", Country="Sweden",Pilot="Olivia Gooris",Time=((math.random(300,375)) + ((math.random(1,99))/100))})
  table.insert(racerList,{Name = "Patrulla Aguila", Country="Spain",Pilot="Mateo Aljandro",Time=((math.random(325,400)) + ((math.random(1,99))/100))})
  table.insert(racerList,{Name = "Patriots", Country="USA",Pilot="Carl Martin",Time=((math.random(175,225)) + ((math.random(1,99))/100))})
  table.insert(racerList,{Name = "Patrouille de France", Country="France",Pilot="Alain Jolie",Time=((math.random(325,400)) + ((math.random(1,99))/100))})
  table.insert(racerList,{Name = "Russian Air Force", Country="Russia",Pilot="** Artem Vasiliev (you)",Time=playerTime})
 
  -- Sort the table based on time
 table.sort(racerList,function(a,b) return a.Time < b.Time end)
  

  -- Display Ranking 
  MessageToAll("",60,"")
  MessageToAll("*** RANKING ***",60,"")
  
  local i=1
  for key,_r in ipairs(racerList) do
    MessageToAll("Rank #"..tostring(i)..": ".._r.Pilot.." (".._r.Name..", ".._r.Country..") -> "..string.format("%.2f",_r.Time).." seconds",20,"")
    if (_r.Name=="Russian Air Force") then
      ranking=i
    end --if
    i=i+1
    
  end --for
  
  -- Comment on the ranking
  if (ranking>5) then
      MessageToAll("Bottom half ranking, not an easy run pilot. We will do better next year for sure. Hey let's fly back to the base, beer is on me.",60,"")
      local rankChat = USERSOUND:New("rank_6_10.ogg")
      rankChat:ToAll()
  end
  
  if ((ranking==4) or (ranking==5)) then
    MessageToAll("Top half ranking! Quite descent for a first race! I am pretty sure you surprised a lot of people here today.",60,"")
    local rankChat = USERSOUND:New("rank_4_5.ogg")
    rankChat:ToAll()

  end
    
  if (ranking==3) then
    MessageToAll("Podium hit!!!! You did third place, I can see the local bar crowd getting crazy from here!",60,"")
    local rankChat = USERSOUND:New("rank_3.ogg")
    rankChat:ToAll()

  end
  
  if (ranking==2) then
    MessageToAll("By the mother of gods!!!! Silver strike!!! Second place. That is some crazy flying you are doing. Congrats man.",60,"")
    local rankChat = USERSOUND:New("rank_2.ogg")
    rankChat:ToAll()
  end
    
  if (ranking==1) then
    MessageToAll("HEAL YEAH!!!! First place you son of a dog! Haha I can see those fancy Blue Angels dudes not getting the chicks tonight. You made it!!! Holy hell what a party waiting for you down there!",60,"")
    local rankChat = USERSOUND:New("rank_1.ogg")
    rankChat:ToAll()
  end
  
end --function


-- The race scheduler get status on the plane and race every 2 seconds.

RaceScheduler = SCHEDULER:New( nil,
  function()
    
    -- Get the plane altitude vs ground
    local coorPlayer = uPlayer:GetCoordinate()
    local alt = uPlayer:GetAltitude() - coorPlayer:GetLandHeight()

    if (not(zoneFire)) then

      -- Compile altitude stats
      totalAltitude = totalAltitude + alt
      ticAltitude = ticAltitude + 1
    
      MessageToAll("Alt "..string.format("%.1f",alt),1,"")
      if (alt<lowAltitude) then
        lowAltitude=alt
      end
    
      if (alt>highAltitude) then
        highAltitude=alt
      end
      
      if (alt<=5) then
        alt5 = alt5 + 1
      end
      
      if ((alt>5) and (alt<=10)) then
        alt10 = alt10 + 1
      end
        
      if ((alt>10) and (alt<=20)) then
        alt20 = alt20 + 1
      end
      
      -- Raise a violation if the altitude is more than 100 meters
      if (alt>=100) then
        zoneViolation = zoneViolation + 1
        buzzSound:ToAll()
        MessageToAll("Zone Violation *Altitude 100+* (" .. tostring(zoneViolation) ..")",1,"")
      end
      
      -- Raise violations for player entering restricted areas (outside river bed)
      if  ((not (targetDead)) and
          ((gpPlayer:IsCompletelyInZone(z1)) or
          (gpPlayer:IsCompletelyInZone(z2)) or
          (gpPlayer:IsCompletelyInZone(z3)) or
          (gpPlayer:IsCompletelyInZone(z4)) or
          (gpPlayer:IsCompletelyInZone(z5)) or
          (gpPlayer:IsCompletelyInZone(z6)) or
          (gpPlayer:IsCompletelyInZone(z7)) or
          (gpPlayer:IsCompletelyInZone(z8)) or
          (gpPlayer:IsCompletelyInZone(z9)) or
          (gpPlayer:IsCompletelyInZone(z10)) or
          (gpPlayer:IsCompletelyInZone(z11)) or
          (gpPlayer:IsCompletelyInZone(z12)) or
          (gpPlayer:IsCompletelyInZone(z13)) or
          (gpPlayer:IsCompletelyInZone(z14)) or
          (gpPlayer:IsCompletelyInZone(z15)))) then
          
        zoneViolation = zoneViolation + 1
        buzzSound:ToAll()
        MessageToAll("Zone Violation *Out of River* (" .. tostring(zoneViolation) ..")",1,"")          
      end
          
  end  --Zonefire
    
    -- End the event when the target truck is dead
    if (targetDead) then
      
            
      if (stopTime==0) then --stop the race timer
        stopTime = timer.getTime()
      end
      
      _a = uPlayer:GetAltitude();
      -- DEBUG MessageToAll("CLIMBING TO 2000: Now "..tostring(_a),2,"")
      
      if (_a>=2500) then
        local timeDiff = stopTime-startTime
        local averageAltitude = totalAltitude / ticAltitude
        MessageToAll("*** EVENT COMPLETE ***\n\nQUALIFICATION Real Time: "..tostring(timeDiff) .." seconds\nLowest Altitude: "..string.format("%.2f",lowAltitude).." meters\nHighest Altitude: "..string.format("%.2f",highAltitude).." meters\nAverage Altitude: "..string.format("%.2f",averageAltitude).." meters\nAlt readings < 5m: "..tostring(alt5).."\nAlt readings 5m to 10m: "..tostring(alt10).."\nAlt readings 10m to 20m: "..tostring(alt20).."\nViolations: "..tostring(zoneViolation),60,"")
        
        -- Calculate final score
        local score = timeDiff + (zoneViolation * 7) - (alt5 * 5) - (alt10 * 2) - (alt20 * 0.5) 
        MessageToAll("\n\n *** FINAL SCORE -> "..string.format("%.2f",score).." seconds ***",60,"")
        
        RankRacer(score)
        
        -- Kill the scheduler
        RaceScheduler.Stop()
      end
    end
    
  end, 
  {}, 1, 2 )
  
  
 


  
  
  
